----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 02.07.2021 08:21:55
-- Design Name: 
-- Module Name: Test_Keyboard - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Test_Keyboard is
--  Port ( );
end Test_Keyboard;

architecture Behavioral of Test_Keyboard is

    component Keyboard is
    Port (CLK : in STD_LOGIC;
  
          PS2Clk : in STD_LOGIC;
          PS2Data : in STD_LOGIC;
        
          Data_read : in STD_LOGIC;
          Data_av : out STD_LOGIC;
          Data : out STD_LOGIC_VECTOR (0 to 7);
        
          alert : out STD_LOGIC);
    end component;
    
    signal CLK : STD_LOGIC := '0';
    signal PS2Clk : STD_LOGIC := '0';
    signal PS2Data : STD_LOGIC := '0';
    signal Data_read : STD_LOGIC := '0';
    signal Data_av : STD_LOGIC := '0';
    signal Data : STD_LOGIC_VECTOR (0 to 7) := (others => '0');
    signal alert : STD_LOGIC := '0';
    
    constant CLK_period : TIME := 10 ns;

begin

    CLK_process : process
    begin
        CLK <= '1';
        wait for CLK_period/2;
        CLK <= '0';
        wait for CLK_period/2;
    end process;

    instance : Keyboard
    port map (CLK => CLK,
          
              PS2Clk => PS2Clk,
              PS2Data => PS2Data, 
            
              Data_read => Data_read,
              Data_av => Data_av,
              Data => Data,
            
              alert => alert);
              
    process
    begin
        PS2Clk <= '1' after 1020 ns, '0' after 1070 ns, '1' after 1120 ns, '0' after 1170 ns, '1' after 1220 ns, '0' after 1270 ns, '1' after 1320 ns, '0' after 1370 ns, '1' after 1420 ns, '0' after 1470 ns, '1' after 1520 ns, '0' after 1570 ns, '1' after 1620 ns, '0' after 1670 ns, '1' after 1720 ns, '0' after 1770 ns, '1' after 1820 ns, '0' after 1870 ns, '1' after 1920 ns, '0' after 1970 ns, '1' after 2020 ns, '0' after 2070 ns;
        PS2Data <= '0' after 1020 ns, '1' after 1120 ns, '0' after 1220 ns, '1' after 1320 ns, '0' after 1420 ns, '1' after 1520 ns, '0' after 1620 ns, '0' after 1720 ns, '0' after 1820 ns, '0' after 1920 ns, '1' after 2020 ns, '0' after 2120 ns;
        Data_read <= '1' after 3000 ns;
        wait;
    end process; 

end Behavioral;
