library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

package ScreenProperties is 
    
    constant Display_CaracterWidht  : Natural := 64;
    constant Display_CaracterHeight : Natural := 64;

    constant screen_width   : natural := 1280;
    constant screen_height  : natural := 1024;
    
    constant X_PulseWidth : Natural := 112;
    constant X_FrontPorch : Natural := 48;
    constant X_BackPorch  : Natural := 248;
    constant Y_PulseWidth : Natural := 3;
    constant Y_FrontPorch : Natural := 1;
    constant Y_BackPorch  : Natural := 38;
        
    subtype X_T is Natural range 0 to screen_width  + X_PulseWidth + X_FrontPorch + X_BackPorch - 1;
    subtype Y_T is Natural range 0 to screen_height + Y_PulseWidth + Y_FrontPorch + Y_BackPorch - 1;
    
    constant C_Blocks : Natural := screen_width/Display_CaracterWidht;
    constant L_Blocks : Natural := screen_height/Display_CaracterHeight;
    constant Ecran_Taille : Natural := C_Blocks * L_Blocks * 7;
    
    constant L_Size : Natural := C_Blocks * 7;
    
    constant Zero_Line : STD_LOGIC_VECTOR (0 to L_Size - 1) := (others => '0');
    
    subtype L_T is Natural range 0 to L_Blocks - 1;
    subtype C_T is Natural range 0 to C_Blocks - 1;
    
end package;
